## trustedqsl 2.3.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8 FATAL_ERROR)

project(TrustedQSL)

if ( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
  ADD_COMPILE_OPTIONS("-fPIC")
endif( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )

if(WIN32)
  set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
  # just windows for now... unix knows how to find libraries better
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmakemodules/")
find_package(OptionalAddSubdirectory REQUIRED)

option(USE_STATIC_MSVCRT "Use a static Visual C++ Runtime when building with MSVC")

if(MSVC AND USE_STATIC_MSVCRT)
foreach(flag_var
        CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
   if(${flag_var} MATCHES "/MD")
      string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
   endif(${flag_var} MATCHES "/MD")
endforeach(flag_var)
else()
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
endif()

add_subdirectory(src) #tqsllib
add_subdirectory(apps)
macro_optional_add_subdirectory(tests)

=== apps/CMakeLists.txt ===
project(tqsl)

set(OSX_ARCH i386 CACHE STRING "Architectures to build for OSX")

string(REPLACE " " ";" CMAKE_OSX_ARCHITECTURES ${OSX_ARCH})

if(WIN32)
	set(wxWidgets_USE_STATIC ON)
	add_definitions(-DCURL_STATICLIB)
	add_definitions(-DXML_STATIC)
endif()

find_package(CURL REQUIRED)
find_package(EXPAT REQUIRED)

find_package(wxWidgets COMPONENTS core base adv html REQUIRED)

find_package(ZLIB REQUIRED)

include(${wxWidgets_USE_FILE})

if(APPLE)
	find_library(CARBON_LIBRARY Carbon)
	find_path(CARBON_INCLUDE_DIR Carbon.h)
endif()

include_directories(${tqsllib_SOURCE_DIR} ${ZLIB_INCLUDE_DIR} ${EXPAT_INCLUDE_DIR} ${CURL_INCLUDE_DIR} ${CARBON_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${BDB_INCLUDE_DIR})

#get version from file

file(STRINGS "tqslversion.ver" TQSLVERSION)
string(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\1" TQSL_VERSION_MAJOR ${TQSLVERSION})
string(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\2" TQSL_VERSION_MINOR ${TQSLVERSION})
string(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\3" TQSL_VERSION_UPDATE ${TQSLVERSION})

# Handle case where version number does not have an update i.e. 2.0
if (TQSL_VERSION_MAJOR STREQUAL ${TQSLVERSION}) 
	string(REGEX REPLACE "([0-9]+)\\.([0-9]+)" "\\1" TQSL_VERSION_MAJOR ${TQSLVERSION})
	string(REGEX REPLACE "([0-9]+)\\.([0-9]+)" "\\2" TQSL_VERSION_MINOR ${TQSLVERSION})
	set(TQSL_VERSION_UPDATE "0")
endif()

#get build # with git

find_program(GIT_PROG git "C:\\Program Files (x86)\\Git\\bin" "C:\\Program Files\\Git\\bin")

if(GIT_PROG) #we can use git
	execute_process(COMMAND ${GIT_PROG} describe RESULT_VARIABLE GITERROR ERROR_QUIET OUTPUT_VARIABLE HEAD_COMMIT OUTPUT_STRIP_TRAILING_WHITESPACE)
	if(NOT GITERROR) #git ran alright
		set(BUILD ${HEAD_COMMIT})
	else()		# Git error - hope this is a source distro
		if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h)
			file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h BUILDSTR REGEX "\\[.*\\]")
			string(REGEX REPLACE ".*\\[(.*)\\].*" "\\1" BUILD ${BUILDSTR})
		endif()
	endif()
else()	# No git, again grab from source
	if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h)
		file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h BUILDSTR REGEX "\\[.*\\]")
		string(REGEX REPLACE ".*\\[(.*)\\].*" "\\1" BUILD ${BUILDSTR})
	endif()
endif()

# If BUILD is set (we have a version) and BUILDSTR is not (we got that build from
# git), then write a tqslbuild.h. Else leave it alone.
if(BUILD AND NOT BUILDSTR)
	configure_file("${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h")
else() #hope this is a source distribution, which will always include a correct tqslbuild
	if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h")
		#but otherwise someone downloaded a snapshot without a buildfile
		set(BUILD "unknown")
		configure_file("${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/tqslbuild.h")
	endif()
endif()

# In case the versions couldn't be deduced, set them
if(NOT ${TQSL_VERSION_MAJOR})
	set(TQSL_VERSION_MAJOR 2)
endif()

if(NOT TQSL_VERSION_MINOR)
	set(TQSL_VERSION_MINOR 1)
endif()

if (NOT TQSL_VERSION_UPDATE)
	set(TQSL_VERSION_UPDATE 0)
endif()

IF(TQSL_VERSION_UPDATE AND NOT TQSL_VERSION_UPDATE EQUAL 0) 
	set(TQSLVERSION "${TQSL_VERSION_MAJOR}.${TQSL_VERSION_MINOR}.${TQSL_VERSION_UPDATE}")
else()
	set(TQSLVERSION "${TQSL_VERSION_MAJOR}.${TQSL_VERSION_MINOR}")
endif()

if(${BUILD} MATCHES "-(alpha|beta|test|rc[0-9])")
	message("${BUILD} is a test build")
	add_definitions(-DTQSL_TEST_BUILD)
endif()

if(WIN32)
	set(TQSLLIB_NAME tqsllib2)
	set(srcdir ${CMAKE_CURRENT_SOURCE_DIR})
	set(TQSL_RCFILE "tqsl.rc")
	configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${TQSL_RCFILE}.in" "${CMAKE_CURRENT_SOURCE_DIR}/${TQSL_RCFILE}")
else()
	set(TQSLLIB_NAME tqsllib)
endif()

if(APPLE)
	set(OSX_ICONFILE "tqslicons.icns")
	set(MACOSX_BUNDLE_INFO_STRING "tqsl")
	set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.arrl.tqsl")
	set(MACOSX_BUNDLE_LONG_VERSION_STRING "TQSL V ${TQSLVERSION} build ${BUILD}")
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${TQSLVERSION}")
	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2017 American Radio Relay League")

	set(MACOSX_BUNDLE_ICON_FILE ${OSX_ICONFILE})
	SET_SOURCE_FILES_PROPERTIES(${OSX_ICONFILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	set(TQSL_RCFILE ${OSX_ICONFILE})
endif()

if(NOT WIN32) #rpath setup
	SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()


set(TQSL_SRC tqsl.cpp extwizard.cpp tqslwiz.cpp dxcc.cpp stationdial.cpp
qsodatadialog.cpp tqslvalidator.cpp tqsl_prefs.cpp wxutil.cpp tqslhelp.cpp
crqwiz.cpp certtree.cpp getpassword.cpp loadcertwiz.cpp loctree.cpp)
set(TQSL_HDR tqslapp.h tqslwiz.h qsodatadialog.h tqslexcept.h
tqslpaths.h stationdial.h dxcc.h tqsl_prefs.h extwizard.h certtree.h
tqslvalidator.h tqslbuild.h tqslhelp.h certtree.h tqslctrls.h util.h
getpassword.h extwizard.h loadcertwiz.h wxutil.h loctree.h tqsltrace.h)
set(TQSL_XPM left.xpm right.xpm bottom.xpm top.xpm key.xpm cert.xpm nocert.xpm
broken-cert.xpm folder.xpm replaced.xpm expired.xpm home.xpm delete.xpm edit.xpm
loc_add_dis.xpm properties.xpm download_dis.xpm loc_add.xpm upload_dis.xpm
download.xpm file_edit_dis.xpm upload.xpm delete_dis.xpm edit_dis.xpm
file_edit.xpm properties_dis.xpm save.xpm import.xpm lotw.xpm)
add_executable(tqsl WIN32 MACOSX_BUNDLE ${TQSL_SRC} ${TQSL_HDR} ${TQSL_XPM} ${TQSL_RCFILE})

target_link_libraries(tqsl ${TQSLLIB_NAME}
  ${wxWidgets_LIBRARIES} ${ZLIB_LIBRARIES} ${CURL_LIBRARIES} ${CARBON_LIBRARY} ${EXPAT_LIBRARIES})

if(NOT APPLE AND NOT WIN32)
	add_definitions("-DCONFDIR=\"${CMAKE_INSTALL_PREFIX}/share/TrustedQSL/\"")
	install(TARGETS tqsl DESTINATION bin)
	install(DIRECTORY help DESTINATION share/TrustedQSL)
	if (CMAKE_INSTALL_PREFIX STREQUAL "/usr")
		install(FILES tqsl.5 DESTINATION share/man/man5)
	else()
		install(FILES tqsl.5 DESTINATION man/man5)
	endif()
	install(FILES icons/key48.png DESTINATION share/pixmaps RENAME TrustedQSL.png)
	install(FILES lang/de/tqslapp.mo DESTINATION share/locale/de/LC_MESSAGES)
	install(FILES lang/es/tqslapp.mo DESTINATION share/locale/es/LC_MESSAGES)
	install(FILES lang/fi/tqslapp.mo DESTINATION share/locale/fi/LC_MESSAGES)
	install(FILES lang/fr/tqslapp.mo DESTINATION share/locale/fr/LC_MESSAGES)
	install(FILES lang/it/tqslapp.mo DESTINATION share/locale/it/LC_MESSAGES)
	install(FILES lang/ja/tqslapp.mo DESTINATION share/locale/ja/LC_MESSAGES)
	install(FILES lang/pt/tqslapp.mo DESTINATION share/locale/pt/LC_MESSAGES)
	install(FILES lang/zh/tqslapp.mo DESTINATION share/locale/zh/LC_MESSAGES)
	install(FILES lang/ru/tqslapp.mo DESTINATION share/locale/ru/LC_MESSAGES)
endif()

=== src/CMakeLists.txt ===
project (tqsllib)

set(OSX_ARCH i386 CACHE STRING "Architectures to build for OSX")

string(REPLACE " " ";" CMAKE_OSX_ARCHITECTURES ${OSX_ARCH})

if(WIN32)
  add_definitions(-DXML_STATIC)
endif()

find_package(EXPAT REQUIRED)
find_package(OpenSSL REQUIRED)
find_package(ZLIB REQUIRED)
FIND_PACKAGE(BDB REQUIRED)

set(TQSLLIB_VERSION_MAJOR 2)
set(TQSLLIB_VERSION_MINOR 5)
set(TQSLLIB_VERSION "${TQSLLIB_VERSION_MAJOR}.${TQSLLIB_VERSION_MINOR}")

add_definitions(-DTQSLLIB_VERSION_MAJOR=${TQSLLIB_VERSION_MAJOR})
add_definitions(-DTQSLLIB_VERSION_MINOR=${TQSLLIB_VERSION_MINOR})

option(TQSLLIB_STATIC "Build static tqsllib" OFF)
if (${TQSLLIB_STATIC})
set(TQSLLIBTYPE STATIC)
else()
set(TQSLLIBTYPE SHARED)
endif()

if(WIN32)
set(TQSLLIB_RCFILE "tqsllib.rc")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${TQSLLIB_RCFILE}.in" "${CMAKE_CURRENT_SOURCE_DIR}/${TQSLLIB_RCFILE}")
set(TQSLLIBNAME "tqsllib2") #for compatibility with existing software
else()
set(TQSLLIBNAME "tqsllib")
endif()

set(TQSLLIB_SRC tqsllib.cpp openssl_cert.cpp adif.cpp xml.cpp location.cpp tqslconvert.cpp cabrillo.cpp)
set(TQSLLIB_HDR xml.h openssl_cert.h tqslexc.h tqsllib.h tqslerrno.h cabrillo.h adif.h tqslconvert.h)

if(APPLE)
find_library(CARBON_LIBRARY Carbon)
find_path(CARBON_INCLUDE_DIR Carbon.h)
endif()
if(WIN32)
#def file for correct 2.x exports
set(TQSLLIB_SRC ${TQSLLIB_SRC} "tqsllib2.def")
endif()

add_library(${TQSLLIBNAME} ${TQSLLIBTYPE} ${TQSLLIB_SRC} ${TQSLLIB_HDR} ${TQSLLIB_RCFILE})
target_link_libraries(${TQSLLIBNAME} ${OPENSSL_LIBRARIES} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${BDB_LIBRARIES} ${CARBON_LIBRARY})
include_directories(${OPENSSL_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR} ${EXPAT_INCLUDE_DIR} ${BDB_INCLUDE_DIR} ${CARBON_INCLUDE_DIR})

if(NOT APPLE AND NOT WIN32)
set_source_files_properties(location.cpp PROPERTIES COMPILE_DEFINITIONS CONFDIR="${CMAKE_INSTALL_PREFIX}/share/TrustedQSL/")
set(HEADERS_TO_INSTALL tqsllib.h tqslerrno.h cabrillo.h adif.h tqslconvert.h)
install(TARGETS tqsllib DESTINATION lib$(LIB_SUFFIX))
install(FILES config.xml DESTINATION share/TrustedQSL)
install(FILES ${HEADERS_TO_INSTALL} DESTINATION include)
endif()

option(BUILD_ALL_EXTRAPROGS "Build all extra programs")

if(BUILD_ALL_EXTRAPROGS)
set(BUILD_GENCRQ ON)
set(BUILD_LOADCERT ON)
set(BUILD_STATIONLOC ON)
set(BUILD_CONVERTER ON)

if(WIN32 AND (BUILD_GENCRQ OR BUILD_LOADCERT OR BUILD_STATIONLOC OR BUILD_CONVERTER))
message("I can't build the tqsllib programs on Windows yet. Disabling them...")
set(BUILD_GENCRQ OFF)
set(BUILD_LOADCERT OFF)
set(BUILD_STATIONLOC OFF)
set(BUILD_CONVERTER OFF)
endif()

else()
option(BUILD_GENCRQ "Build gen_crq")
option(BUILD_LOADCERT "Build load_cert")
option(BUILD_STATIONLOC "Build station_loc")
option(BUILD_CONVERTER "Build converter")

endif(BUILD_ALL_EXTRAPROGS)

if(BUILD_GENCRQ)
add_executable(gen_crq gen_crq.cpp)
target_link_libraries(gen_crq ${TQSLLIBNAME})
endif(BUILD_GENCRQ)

if(BUILD_LOADCERT)
add_executable(load_cert load_cert.cpp)
target_link_libraries(load_cert ${TQSLLIBNAME})
endif(BUILD_LOADCERT)

if(BUILD_STATIONLOC)
add_executable(station_loc station_loc.cpp)
target_link_libraries(station_loc ${TQSLLIBNAME})
endif(BUILD_STATIONLOC)

if(BUILD_CONVERTER)
add_executable(converter converter.cpp)
target_link_libraries(converter ${TQSLLIBNAME})
endif(BUILD_CONVERTER)

=== debian/changelog ===
trustedqsl (2.3.1-1build2) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 08:53:40 +0000

trustedqsl (2.3.1-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 16:55:06 +0000

trustedqsl (2.3.1-1) unstable; urgency=medium

  * New upstream release
  * Debian packaging:
    - clean up old unused debian/patches (previously merged upstream)

 -- Kamal Mostafa <kamal@whence.com>  Mon, 11 Sep 2017 05:49:19 -0700

=== debian/control ===
Source: trustedqsl
Section: hamradio
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Kamal Mostafa <kamal@whence.com>, Jaime Robles <jaime@debian.org>, Patrick Ouellette <pouelle@debian.org>, Jerry Stueve <k4int@arrl.net>, Colin Tuckley <colint@debian.org>
Standards-Version: 4.0.0
Build-Depends: debhelper (>= 9), cmake, libwxgtk3.0-dev, zlib1g-dev, libexpat1-dev, libssl-dev, libdb-dev, libcurl4-openssl-dev
Homepage: http://sourceforge.net/projects/trustedqsl/
Vcs-Git: git://git.code.sf.net/p/trustedqsl/tqsl
Vcs-Browser: https://sourceforge.net/p/trustedqsl/tqsl/ci/master/tree/

Package: trustedqsl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: QSL log signing for the Logbook of the World (LoTW)
 Open source libraries and utilities to support using digital signatures
 for amateur radio QSL information.
 .
 A QSL is a confirmation of contact between two amateur radio stations.
 The ARRL Logbook of the World project is a database which collects
 data about contacts between amateur stations (QSOs). This package 
 provides the 'tqsl' program for maintaining your digital certificates
 for LoTW and signing and uploading QSO log files.

=== debian/watch ===
version=3

# older versions, e.g. TrustedQSL-1.13 ==> 1.13
#http://sf.net/trustedqsl/TrustedQSL-([\d\.]+)\.tar\.gz

# newer versions (since 1.14.2) should work with standard sourceforge scanner
#http://sf.net/trustedqsl/tqsl-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

# versions since 2.3 are distributed from www.arrl.org
http://www.arrl.org/tqsl-download .*/tqsl-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## trustedqsl 2.4.3

=== apps/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	find_path(CARBON_INCLUDE_DIR Carbon.h)
 endif()
 
-include_directories(${tqsllib_SOURCE_DIR} ${ZLIB_INCLUDE_DIR} ${EXPAT_INCLUDE_DIR} ${CURL_INCLUDE_DIR} ${CARBON_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${BDB_INCLUDE_DIR})
+include_directories(${tqsllib_SOURCE_DIR} ${ZLIB_INCLUDE_DIR} ${EXPAT_INCLUDE_DIR} ${CURL_INCLUDE_DIR} ${CARBON_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${BDB_INCLUDE_DIR} ${LMDB_INCLUDE_DIR})
 
 #get version from file
 
@@ -112,7 +112,7 @@
 	set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.arrl.tqsl")
 	set(MACOSX_BUNDLE_LONG_VERSION_STRING "TQSL V ${TQSLVERSION} build ${BUILD}")
 	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${TQSLVERSION}")
-	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2017 American Radio Relay League")
+	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2018 American Radio Relay League")
 
 	set(MACOSX_BUNDLE_ICON_FILE ${OSX_ICONFILE})
 	SET_SOURCE_FILES_PROPERTIES(${OSX_ICONFILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
@@ -129,11 +129,13 @@
 
 set(TQSL_SRC tqsl.cpp extwizard.cpp tqslwiz.cpp dxcc.cpp stationdial.cpp
 qsodatadialog.cpp tqslvalidator.cpp tqsl_prefs.cpp wxutil.cpp tqslhelp.cpp
-crqwiz.cpp certtree.cpp getpassword.cpp loadcertwiz.cpp loctree.cpp)
+crqwiz.cpp certtree.cpp getpassword.cpp loadcertwiz.cpp loctree.cpp
+jsonreader.cpp  jsonval.cpp  jsonwriter.cpp)
 set(TQSL_HDR tqslapp.h tqslwiz.h qsodatadialog.h tqslexcept.h
 tqslpaths.h stationdial.h dxcc.h tqsl_prefs.h extwizard.h certtree.h
 tqslvalidator.h tqslbuild.h tqslhelp.h certtree.h tqslctrls.h util.h
-getpassword.h extwizard.h loadcertwiz.h wxutil.h loctree.h tqsltrace.h)
+getpassword.h extwizard.h loadcertwiz.h wxutil.h loctree.h tqsltrace.h
+json_defs.h  jsonreader.h  jsonval.h  jsonwriter.h)
 set(TQSL_XPM left.xpm right.xpm bottom.xpm top.xpm key.xpm cert.xpm nocert.xpm
 broken-cert.xpm folder.xpm replaced.xpm expired.xpm home.xpm delete.xpm edit.xpm
 loc_add_dis.xpm properties.xpm download_dis.xpm loc_add.xpm upload_dis.xpm
@@ -144,8 +146,13 @@
 target_link_libraries(tqsl ${TQSLLIB_NAME}
   ${wxWidgets_LIBRARIES} ${ZLIB_LIBRARIES} ${CURL_LIBRARIES} ${CARBON_LIBRARY} ${EXPAT_LIBRARIES})
 
+if(WIN32)
+	set(UPDATER_SRC tqslupdater.cpp)
+	add_executable(tqslupdater WIN32 ${UPDATER_SRC} ${TQSL_HDR})
+	target_link_libraries(tqslupdater ${wxWidgets_LIBRARIES} ${CURL_LIBRARIES})
+endif()
+
 if(NOT APPLE AND NOT WIN32)
-	add_definitions("-DCONFDIR=\"${CMAKE_INSTALL_PREFIX}/share/TrustedQSL/\"")
 	install(TARGETS tqsl DESTINATION bin)
 	install(DIRECTORY help DESTINATION share/TrustedQSL)
 	if (CMAKE_INSTALL_PREFIX STREQUAL "/usr")
@@ -158,9 +165,13 @@
 	install(FILES lang/es/tqslapp.mo DESTINATION share/locale/es/LC_MESSAGES)
 	install(FILES lang/fi/tqslapp.mo DESTINATION share/locale/fi/LC_MESSAGES)
 	install(FILES lang/fr/tqslapp.mo DESTINATION share/locale/fr/LC_MESSAGES)
+	install(FILES lang/hi_IN/tqslapp.mo DESTINATION share/locale/hi_IN/LC_MESSAGES)
 	install(FILES lang/it/tqslapp.mo DESTINATION share/locale/it/LC_MESSAGES)
 	install(FILES lang/ja/tqslapp.mo DESTINATION share/locale/ja/LC_MESSAGES)
 	install(FILES lang/pt/tqslapp.mo DESTINATION share/locale/pt/LC_MESSAGES)
 	install(FILES lang/zh/tqslapp.mo DESTINATION share/locale/zh/LC_MESSAGES)
 	install(FILES lang/ru/tqslapp.mo DESTINATION share/locale/ru/LC_MESSAGES)
+	install(FILES languages.dat DESTINATION share/TrustedQSL)
+	install(FILES cab_modes.dat DESTINATION share/TrustedQSL)
+
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,6 @@
 find_package(EXPAT REQUIRED)
 find_package(OpenSSL REQUIRED)
 find_package(ZLIB REQUIRED)
-FIND_PACKAGE(BDB REQUIRED)
 
 set(TQSLLIB_VERSION_MAJOR 2)
 set(TQSLLIB_VERSION_MINOR 5)
@@ -48,13 +47,13 @@
 endif()
 
 add_library(${TQSLLIBNAME} ${TQSLLIBTYPE} ${TQSLLIB_SRC} ${TQSLLIB_HDR} ${TQSLLIB_RCFILE})
-target_link_libraries(${TQSLLIBNAME} ${OPENSSL_LIBRARIES} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${BDB_LIBRARIES} ${CARBON_LIBRARY})
+target_link_libraries(${TQSLLIBNAME} ${OPENSSL_LIBRARIES} ${EXPAT_LIBRARIES} ${ZLIB_LIBRARIES} ${BDB_LIBRARIES} ${LMDB_LIBRARIES} ${CARBON_LIBRARY})
 include_directories(${OPENSSL_INCLUDE_DIR} ${ZLIB_INCLUDE_DIR} ${EXPAT_INCLUDE_DIR} ${BDB_INCLUDE_DIR} ${CARBON_INCLUDE_DIR})
 
 if(NOT APPLE AND NOT WIN32)
 set_source_files_properties(location.cpp PROPERTIES COMPILE_DEFINITIONS CONFDIR="${CMAKE_INSTALL_PREFIX}/share/TrustedQSL/")
 set(HEADERS_TO_INSTALL tqsllib.h tqslerrno.h cabrillo.h adif.h tqslconvert.h)
-install(TARGETS tqsllib DESTINATION lib$(LIB_SUFFIX))
+install(TARGETS tqsllib DESTINATION lib${LIB_SUFFIX})
 install(FILES config.xml DESTINATION share/TrustedQSL)
 install(FILES ${HEADERS_TO_INSTALL} DESTINATION include)
 endif()

=== debian/changelog ===
trustedqsl (2.4.3-1) unstable; urgency=medium

  * Team upload with new upstream release.
  * Run wrap-and-sort -st.
  * Create packaging repo on salsa.
  * Add jquery-1.7.1.js source in debian/missing-sources/.

 -- Christoph Berg <myon@debian.org>  Sun, 13 Jan 2019 14:35:55 +0100

=== debian/control ===
Source: trustedqsl
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders:
 Kamal Mostafa <kamal@whence.com>,
 Jaime Robles <jaime@debian.org>,
 Patrick Ouellette <pouelle@debian.org>,
 Jerry Stueve <k4int@arrl.net>,
 Colin Tuckley <colint@debian.org>,
Standards-Version: 4.3.0
Build-Depends:
 cmake,
 debhelper (>= 9),
 libcurl4-openssl-dev,
 libdb-dev,
 libexpat1-dev,
 libssl-dev,
 libwxgtk3.0-dev,
 zlib1g-dev,
Homepage: http://sourceforge.net/projects/trustedqsl/
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/trustedqsl.git
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/trustedqsl

Package: trustedqsl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: QSL log signing for the Logbook of the World (LoTW)
 Open source libraries and utilities to support using digital signatures
 for amateur radio QSL information.
 .
 A QSL is a confirmation of contact between two amateur radio stations.
 The ARRL Logbook of the World project is a database which collects
 data about contacts between amateur stations (QSOs). This package
 provides the 'tqsl' program for maintaining your digital certificates
 for LoTW and signing and uploading QSO log files.

## trustedqsl 2.4.7

=== debian/changelog ===
trustedqsl (2.4.7-2) unstable; urgency=medium

  * Rebuild against wxWidgets GTK 3. (Closes: #933437)
  * Remove apps/tqslbuild.h on clean, it's updated at build time with git
    information.
  * Run reprotest with diffoscope enabled.

 -- Christoph Berg <myon@debian.org>  Tue, 30 Jul 2019 22:21:00 +0200

trustedqsl (2.4.7-1) experimental; urgency=medium

  * New upstream release.
  * Add myself to Uploaders.
  * Add debian/gitlab-ci.yml.

 -- Christoph Berg <myon@debian.org>  Sun, 05 May 2019 17:43:25 +0200

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  Patrick Ouellette <pouelle@debian.org>,
  Jerry Stueve <k4int@arrl.net>,
  Colin Tuckley <colint@debian.org>,
+ Christoph Berg <myon@debian.org>,
 Standards-Version: 4.3.0
 Build-Depends:
  cmake,
@@ -16,7 +17,7 @@
  libdb-dev,
  libexpat1-dev,
  libssl-dev,
- libwxgtk3.0-dev,
+ libwxgtk3.0-gtk3-dev,
  zlib1g-dev,
 Homepage: http://sourceforge.net/projects/trustedqsl/
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/trustedqsl.git

## trustedqsl 2.5.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,29 @@
 if ( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
   ADD_COMPILE_OPTIONS("-fPIC")
 endif( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
+
+# Pre-set LIB_SUFFIX for 64-bit platforms
+IF (CMAKE_SHARED_LIBRARY_PREFIX STREQUAL "lib64")
+  SET (LIB_SUFFIX "64")
+ENDIF()
+
+# Make sure that there's a value for LIB_SUFFIX
+IF (NOT CMAKE_SHARED_LIBRARY_PREFIX AND NOT LIB_SUFFIX) 
+  IF (NOT APPLE)
+  # check 64 bit
+    IF (CMAKE_SIZEOF_VOID_P EQUAL 4)
+      SET (LIB_SUFFIX "")
+    ELSE (CMAKE_SIZEOF_VOID_P EQUAL 4)
+      SET (LIB_SUFFIX "64")
+    ENDIF (CMAKE_SIZEOF_VOID_P EQUAL 4)
+  ELSE (NOT APPLE)
+    SET (LIB_SUFFIX "")
+  ENDIF (NOT APPLE)
+  # BSD does not use lib64 for 64bit libs
+  IF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD" OR ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
+    SET (LIB_SUFFIX "")
+  ENDIF()
+ENDIF (NOT CMAKE_SHARED_LIBRARY_PREFIX AND NOT LIB_SUFFIX) 
 
 if(WIN32)
   set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
@@ -31,6 +54,21 @@
 	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall")
 endif()
 
+# Prefer LMDB, fall back to BDB if that's not available
+find_package(LMDB)
+if(NOT LMDB_FOUND)
+	set (LMDB_LIBRARIES "")
+	find_package(BDB REQUIRED)
+	set (LMDB_INCLUDE_DIR "")
+else()
+	add_definitions(-DUSE_LMDB)
+	set (BDB_INCLUDE_DIR "")
+endif()
+
+if(NOT APPLE AND NOT WIN32)
+	add_definitions("-DCONFDIR=\"${CMAKE_INSTALL_PREFIX}/share/TrustedQSL/\"")
+endif()
+
 add_subdirectory(src) #tqsllib
 add_subdirectory(apps)
 macro_optional_add_subdirectory(tests)

=== apps/CMakeLists.txt ===
--- 
+++ 
@@ -97,6 +97,10 @@
 	add_definitions(-DTQSL_TEST_BUILD)
 endif()
 
+if(APPLE)
+	add_definitions(-DOSX_PLATFORM="${OSX_PLATFORM}")
+endif()
+
 if(WIN32)
 	set(TQSLLIB_NAME tqsllib2)
 	set(srcdir ${CMAKE_CURRENT_SOURCE_DIR})
@@ -112,7 +116,7 @@
 	set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.arrl.tqsl")
 	set(MACOSX_BUNDLE_LONG_VERSION_STRING "TQSL V ${TQSLVERSION} build ${BUILD}")
 	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${TQSLVERSION}")
-	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2018 American Radio Relay League")
+	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2019 American Radio Relay League")
 
 	set(MACOSX_BUNDLE_ICON_FILE ${OSX_ICONFILE})
 	SET_SOURCE_FILES_PROPERTIES(${OSX_ICONFILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)

=== debian/changelog ===
trustedqsl (2.5.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:27:59 +0100

trustedqsl (2.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.5.1 (Closes: #944994)
  * Update to debhelper compat level 12
  * Refresh patches against new upstream version
  * Add a patch for typos in the source
  * Freshen dates in debian/copyright
  * Bump Standards-Version to 4.4.1
  * Set "Rules-Requires-Root: no" in debian/control
  * Set export DEB_BUILD_HARDENING=1 in debian/rules

 -- tony mancill <tmancill@debian.org>  Sun, 17 Nov 2019 20:53:28 -0800

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
  Jerry Stueve <k4int@arrl.net>,
  Colin Tuckley <colint@debian.org>,
  Christoph Berg <myon@debian.org>,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Build-Depends:
  cmake,
- debhelper (>= 9),
+ debhelper-compat (= 12),
  libcurl4-openssl-dev,
  libdb-dev,
  libexpat1-dev,
@@ -22,6 +22,7 @@
 Homepage: http://sourceforge.net/projects/trustedqsl/
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/trustedqsl.git
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/trustedqsl
+Rules-Requires-Root: no
 
 Package: trustedqsl
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Disable WXDEBUG assertions, which are on by default in wx3.0.
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@

override_dh_install:
	# Omit the 5 header files that the build installs to /usr/include
	# (they would belong in a -dev package)
	dh_install
	rm -r debian/trustedqsl/usr/include

override_dh_installman:
	# Duplicate the tqsl.5 man page for tqsl.1 but fix its section
	# for dh_installman (see debian/trustedqsl.manpages).
	mkdir -p debian/tmp
	sed 's/^\.TH TQSL 5/.TH TQSL 1/' < apps/tqsl.5  \
	    > debian/tmp/tqsl.1
	dh_installman

=== debian/watch ===
--- 
+++ 
@@ -7,4 +7,4 @@
 #http://sf.net/trustedqsl/tqsl-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
 
 # versions since 2.3 are distributed from www.arrl.org
-http://www.arrl.org/tqsl-download .*/tqsl-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
+https://www.arrl.org/tqsl-download .*/tqsl-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## trustedqsl 2.5.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,28 +6,27 @@
   ADD_COMPILE_OPTIONS("-fPIC")
 endif( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
 
-# Pre-set LIB_SUFFIX for 64-bit platforms
-IF (CMAKE_SHARED_LIBRARY_PREFIX STREQUAL "lib64")
+SET (LINUX FALSE)
+IF (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
+    SET(LINUX TRUE)
+ENDIF ()
+
+SET (LIB_SUFFIX "")
+
+# Pre-set LIB_SUFFIX for 64-bit Linux platforms
+IF (LINUX AND CMAKE_SHARED_LIBRARY_PREFIX STREQUAL "lib64")
   SET (LIB_SUFFIX "64")
 ENDIF()
 
 # Make sure that there's a value for LIB_SUFFIX
-IF (NOT CMAKE_SHARED_LIBRARY_PREFIX AND NOT LIB_SUFFIX) 
-  IF (NOT APPLE)
+IF (LINUX AND NOT CMAKE_SHARED_LIBRARY_PREFIX AND NOT LIB_SUFFIX) 
   # check 64 bit
     IF (CMAKE_SIZEOF_VOID_P EQUAL 4)
       SET (LIB_SUFFIX "")
     ELSE (CMAKE_SIZEOF_VOID_P EQUAL 4)
       SET (LIB_SUFFIX "64")
     ENDIF (CMAKE_SIZEOF_VOID_P EQUAL 4)
-  ELSE (NOT APPLE)
-    SET (LIB_SUFFIX "")
-  ENDIF (NOT APPLE)
-  # BSD does not use lib64 for 64bit libs
-  IF (${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD" OR ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD")
-    SET (LIB_SUFFIX "")
-  ENDIF()
-ENDIF (NOT CMAKE_SHARED_LIBRARY_PREFIX AND NOT LIB_SUFFIX) 
+ENDIF (LINUX AND NOT CMAKE_SHARED_LIBRARY_PREFIX AND NOT LIB_SUFFIX) 
 
 if(WIN32)
   set(CMAKE_FIND_LIBRARY_SUFFIXES .lib .a ${CMAKE_FIND_LIBRARY_SUFFIXES})
@@ -69,6 +68,72 @@
 	add_definitions("-DCONFDIR=\"${CMAKE_INSTALL_PREFIX}/share/TrustedQSL/\"")
 endif()
 
+# Get version number
+
+file(STRINGS "apps/tqslversion.ver" TQSLVERSION)
+string(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\1" TQSL_VERSION_MAJOR ${TQSLVERSION})
+string(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\2" TQSL_VERSION_MINOR ${TQSLVERSION})
+string(REGEX REPLACE "([0-9]+)\\.([0-9]+)\\.([0-9]+)" "\\3" TQSL_VERSION_UPDATE ${TQSLVERSION})
+
+# Handle case where version number does not have an update i.e. 2.0
+if (TQSL_VERSION_MAJOR STREQUAL ${TQSLVERSION}) 
+	string(REGEX REPLACE "([0-9]+)\\.([0-9]+)" "\\1" TQSL_VERSION_MAJOR ${TQSLVERSION})
+	string(REGEX REPLACE "([0-9]+)\\.([0-9]+)" "\\2" TQSL_VERSION_MINOR ${TQSLVERSION})
+	set(TQSL_VERSION_UPDATE "0")
+endif()
+
+#get build # with git
+
+find_program(GIT_PROG git "C:\\Program Files (x86)\\Git\\bin" "C:\\Program Files\\Git\\bin")
+
+if(GIT_PROG) #we can use git
+	execute_process(COMMAND ${GIT_PROG} describe RESULT_VARIABLE GITERROR ERROR_QUIET OUTPUT_VARIABLE HEAD_COMMIT OUTPUT_STRIP_TRAILING_WHITESPACE)
+	if(NOT GITERROR) #git ran alright
+		set(BUILD ${HEAD_COMMIT})
+	else()		# Git error - hope this is a source distro
+		if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h)
+			file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h BUILDSTR REGEX "\\[.*\\]")
+			string(REGEX REPLACE ".*\\[(.*)\\].*" "\\1" BUILD ${BUILDSTR})
+		endif()
+	endif()
+else()	# No git, again grab from source
+	if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h)
+		file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h BUILDSTR REGEX "\\[.*\\]")
+		string(REGEX REPLACE ".*\\[(.*)\\].*" "\\1" BUILD ${BUILDSTR})
+	endif()
+endif()
+
+# If BUILD is set (we have a version) and BUILDSTR is not (we got that build from
+# git), then write a tqslbuild.h. Else leave it alone.
+if(BUILD AND NOT BUILDSTR)
+	configure_file("${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h")
+else() #hope this is a source distribution, which will always include a correct tqslbuild
+	if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h")
+		#but otherwise someone downloaded a snapshot without a buildfile
+		set(BUILD "unknown")
+		configure_file("${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h.in" "${CMAKE_CURRENT_SOURCE_DIR}/apps/tqslbuild.h")
+	endif()
+endif()
+
+# In case the versions couldn't be deduced, set them
+if(NOT ${TQSL_VERSION_MAJOR})
+	set(TQSL_VERSION_MAJOR 2)
+endif()
+
+if(NOT TQSL_VERSION_MINOR)
+	set(TQSL_VERSION_MINOR 1)
+endif()
+
+if (NOT TQSL_VERSION_UPDATE)
+	set(TQSL_VERSION_UPDATE 0)
+endif()
+
+IF(TQSL_VERSION_UPDATE AND NOT TQSL_VERSION_UPDATE EQUAL 0) 
+	set(TQSLVERSION "${TQSL_VERSION_MAJOR}.${TQSL_VERSION_MINOR}.${TQSL_VERSION_UPDATE}")
+else()
+	set(TQSLVERSION "${TQSL_VERSION_MAJOR}.${TQSL_VERSION_MINOR}")
+endif()
+#
 add_subdirectory(src) #tqsllib
 add_subdirectory(apps)
 macro_optional_add_subdirectory(tests)

=== apps/CMakeLists.txt ===
project(tqsl)

set(OSX_ARCH i386 CACHE STRING "Architectures to build for OSX")

string(REPLACE " " ";" CMAKE_OSX_ARCHITECTURES ${OSX_ARCH})

if(WIN32)
	set(wxWidgets_USE_STATIC ON)
	add_definitions(-DCURL_STATICLIB)
	add_definitions(-DXML_STATIC)
endif()

find_package(CURL REQUIRED)
find_package(EXPAT REQUIRED)

find_package(wxWidgets COMPONENTS core base adv html REQUIRED)

find_package(ZLIB REQUIRED)

include(${wxWidgets_USE_FILE})

if(APPLE)
	find_library(CARBON_LIBRARY Carbon)
	find_path(CARBON_INCLUDE_DIR Carbon.h)
endif()

include_directories(${tqsllib_SOURCE_DIR} ${ZLIB_INCLUDE_DIR} ${EXPAT_INCLUDE_DIR} ${CURL_INCLUDE_DIR} ${CARBON_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR} ${BDB_INCLUDE_DIR} ${LMDB_INCLUDE_DIR})

if(${BUILD} MATCHES "-(alpha|beta|test|rc[0-9])")
	message("${BUILD} is a test build")
	add_definitions(-DTQSL_TEST_BUILD)
endif()

if(APPLE)
	add_definitions(-DOSX_PLATFORM="${OSX_PLATFORM}")
endif()

if(WIN32)
	set(TQSLLIB_NAME tqsllib2)
	set(srcdir ${CMAKE_CURRENT_SOURCE_DIR})
	set(TQSL_RCFILE "tqsl.rc")
	configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${TQSL_RCFILE}.in" "${CMAKE_CURRENT_SOURCE_DIR}/${TQSL_RCFILE}")
else()
	set(TQSLLIB_NAME tqsllib)
endif()

if(APPLE)
	set(OSX_ICONFILE "tqslicons.icns")
	set(MACOSX_BUNDLE_INFO_STRING "tqsl")
	set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.arrl.tqsl")
	set(MACOSX_BUNDLE_LONG_VERSION_STRING "TQSL V ${TQSLVERSION} build ${BUILD}")
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${TQSLVERSION}")
	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2020 American Radio Relay League")

	set(MACOSX_BUNDLE_ICON_FILE ${OSX_ICONFILE})
	SET_SOURCE_FILES_PROPERTIES(${OSX_ICONFILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
	set(TQSL_RCFILE ${OSX_ICONFILE})
endif()

if (NOT DEFINED TQSL_RPATH)
	SET (TQSL_RPATH FALSE)
endif ()

if(NOT WIN32) #rpath setup
	SET(CMAKE_SKIP_BUILD_RPATH ${TQSL_RPATH})
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH ${TQSL_RPATH}) 
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
endif()


set(TQSL_SRC tqsl.cpp extwizard.cpp tqslwiz.cpp dxcc.cpp stationdial.cpp
qsodatadialog.cpp tqslvalidator.cpp tqsl_prefs.cpp wxutil.cpp tqslhelp.cpp
crqwiz.cpp certtree.cpp getpassword.cpp loadcertwiz.cpp loctree.cpp
jsonreader.cpp  jsonval.cpp  jsonwriter.cpp)
set(TQSL_HDR tqslapp.h tqslwiz.h qsodatadialog.h tqslexcept.h
tqslpaths.h stationdial.h dxcc.h tqsl_prefs.h extwizard.h certtree.h
tqslvalidator.h tqslbuild.h tqslhelp.h certtree.h tqslctrls.h util.h
getpassword.h extwizard.h loadcertwiz.h wxutil.h loctree.h tqsltrace.h
json_defs.h  jsonreader.h  jsonval.h  jsonwriter.h)
set(TQSL_XPM left.xpm right.xpm bottom.xpm top.xpm key.xpm cert.xpm nocert.xpm
broken-cert.xpm folder.xpm replaced.xpm expired.xpm home.xpm delete.xpm edit.xpm
loc_add_dis.xpm properties.xpm download_dis.xpm loc_add.xpm upload_dis.xpm
download.xpm file_edit_dis.xpm upload.xpm delete_dis.xpm edit_dis.xpm
file_edit.xpm properties_dis.xpm save.xpm import.xpm lotw.xpm)
add_executable(tqsl WIN32 MACOSX_BUNDLE ${TQSL_SRC} ${TQSL_HDR} ${TQSL_XPM} ${TQSL_RCFILE})

target_link_libraries(tqsl ${TQSLLIB_NAME}
  ${wxWidgets_LIBRARIES} ${ZLIB_LIBRARIES} ${CURL_LIBRARIES} ${CARBON_LIBRARY} ${EXPAT_LIBRARIES})

if(WIN32)
	set(UPDATER_SRC tqslupdater.cpp)
	add_executable(tqslupdater WIN32 ${UPDATER_SRC} ${TQSL_HDR})
	target_link_libraries(tqslupdater ${wxWidgets_LIBRARIES} ${CURL_LIBRARIES})
endif()

if(NOT APPLE AND NOT WIN32)
	install(TARGETS tqsl DESTINATION bin)
	install(DIRECTORY help DESTINATION share/TrustedQSL)
	install(FILES tqsl.5 DESTINATION ${CMAKE_INSTALL_MANDIR}/man5)
	install(FILES icons/key48.png DESTINATION share/pixmaps RENAME TrustedQSL.png)
	install(FILES lang/de/tqslapp.mo DESTINATION share/locale/de/LC_MESSAGES)
	install(FILES lang/es/tqslapp.mo DESTINATION share/locale/es/LC_MESSAGES)
	install(FILES lang/fi/tqslapp.mo DESTINATION share/locale/fi/LC_MESSAGES)
	install(FILES lang/fr/tqslapp.mo DESTINATION share/locale/fr/LC_MESSAGES)
	install(FILES lang/hi_IN/tqslapp.mo DESTINATION share/locale/hi_IN/LC_MESSAGES)
	install(FILES lang/it/tqslapp.mo DESTINATION share/locale/it/LC_MESSAGES)
	install(FILES lang/ja/tqslapp.mo DESTINATION share/locale/ja/LC_MESSAGES)
	install(FILES lang/pt/tqslapp.mo DESTINATION share/locale/pt/LC_MESSAGES)
	install(FILES lang/zh/tqslapp.mo DESTINATION share/locale/zh/LC_MESSAGES)
	install(FILES lang/ru/tqslapp.mo DESTINATION share/locale/ru/LC_MESSAGES)
	install(FILES languages.dat DESTINATION share/TrustedQSL)
	install(FILES cab_modes.dat DESTINATION share/TrustedQSL)

endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,9 @@
 
 add_definitions(-DTQSLLIB_VERSION_MAJOR=${TQSLLIB_VERSION_MAJOR})
 add_definitions(-DTQSLLIB_VERSION_MINOR=${TQSLLIB_VERSION_MINOR})
+add_definitions(-DTQSL_VERSION_MAJOR=${TQSL_VERSION_MAJOR})
+add_definitions(-DTQSL_VERSION_MINOR=${TQSL_VERSION_MINOR})
+add_definitions(-DTQSL_VERSION_UPDATE=${TQSL_VERSION_UPDATE})
 
 option(TQSLLIB_STATIC "Build static tqsllib" OFF)
 if (${TQSLLIB_STATIC})

=== debian/changelog ===
trustedqsl (2.5.4-1) unstable; urgency=medium

  * New upstream version 2.5.4

 -- tony mancill <tmancill@debian.org>  Sun, 24 May 2020 11:06:46 -0700

trustedqsl (2.5.3-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Mute lintian warning for src/doxygen/html/menu.js.

  [ tony mancill ]
  * New upstream version 2.5.3
  * Refresh patches against new upstream version
  * Set CMAKE_INSTALL_MANDIR during build
  * Bump Standards-Version to 4.5.0
  * Add myself to Uploaders

 -- tony mancill <tmancill@debian.org>  Sat, 02 May 2020 10:43:52 -0700

## trustedqsl 2.5.5

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,6 @@
 endif()
 
 find_package(EXPAT REQUIRED)
-find_package(OpenSSL REQUIRED)
 find_package(ZLIB REQUIRED)
 
 set(TQSLLIB_VERSION_MAJOR 2)

=== debian/changelog ===
trustedqsl (2.5.5-1) unstable; urgency=medium

  * New upstream version 2.5.5

 -- tony mancill <tmancill@debian.org>  Sun, 13 Sep 2020 11:51:22 -0700

=== debian/control ===
Source: trustedqsl
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Kamal Mostafa <kamal@whence.com>,
           Jaime Robles <jaime@debian.org>,
           Patrick Ouellette <pouelle@debian.org>,
           Jerry Stueve <k4int@arrl.net>,
           Colin Tuckley <colint@debian.org>,
           Christoph Berg <myon@debian.org>,
           tony mancill <tmancill@debian.org>
Section: hamradio
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               libcurl4-openssl-dev,
               libdb-dev,
               libexpat1-dev,
               libssl-dev,
               libwxgtk3.0-gtk3-dev,
               zlib1g-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/trustedqsl
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/trustedqsl.git
Homepage: https://sourceforge.net/projects/trustedqsl/
Rules-Requires-Root: no

Package: trustedqsl
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: QSL log signing for the Logbook of the World (LoTW)
 Open source libraries and utilities to support using digital signatures
 for amateur radio QSL information.
 .
 A QSL is a confirmation of contact between two amateur radio stations.
 The ARRL Logbook of the World project is a database which collects
 data about contacts between amateur stations (QSOs). This package
 provides the 'tqsl' program for maintaining your digital certificates
 for LoTW and signing and uploading QSO log files.

## trustedqsl 2.5.6

=== debian/changelog ===
trustedqsl (2.5.6-1) unstable; urgency=medium

  * New upstream version 2.5.6
  * Update to debhelper compat level 13
  * Freshen debian/copyright
  * Refresh patches for new upstream release

 -- tony mancill <tmancill@debian.org>  Sun, 15 Nov 2020 15:31:21 -0800

## trustedqsl 2.5.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,8 @@
 cmake_minimum_required (VERSION 2.8 FATAL_ERROR)
 
 project(TrustedQSL)
+
+find_package(OpenSSL REQUIRED)
 
 if ( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
   ADD_COMPILE_OPTIONS("-fPIC")

=== apps/CMakeLists.txt ===
--- 
+++ 
@@ -91,7 +91,7 @@
 if(WIN32)
 	set(UPDATER_SRC tqslupdater.cpp)
 	add_executable(tqslupdater WIN32 ${UPDATER_SRC} ${TQSL_HDR})
-	target_link_libraries(tqslupdater ${wxWidgets_LIBRARIES} ${CURL_LIBRARIES})
+	target_link_libraries(tqslupdater ${wxWidgets_LIBRARIES} ${CURL_LIBRARIES} ${OPENSSL_LIBRARIES})
 endif()
 
 if(NOT APPLE AND NOT WIN32)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,10 @@
 
 if(WIN32)
   add_definitions(-DXML_STATIC)
+endif()
+
+if(APPLE)
+  set(CMAKE_MACOSX_RPATH 0)
 endif()
 
 find_package(EXPAT REQUIRED)

=== debian/changelog ===
trustedqsl (2.5.7-1) unstable; urgency=medium

  * New upstream version 2.5.7
  * Refresh patches

 -- tony mancill <tmancill@debian.org>  Sat, 21 Nov 2020 14:45:31 -0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Section: hamradio
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libcurl4-openssl-dev,
                libdb-dev,
                libexpat1-dev,

=== debian/rules ===
--- 
+++ 
@@ -25,3 +25,5 @@
 	    > debian/tmp/tqsl.1
 	dh_installman
 
+override_dh_auto_configure:
+	dh_auto_configure -- -DCMAKE_INSTALL_MANDIR=/usr/share/man

=== debian/watch ===
--- 
+++ 
@@ -1,4 +1,4 @@
-version=3
+version=4
 
 # older versions, e.g. TrustedQSL-1.13 ==> 1.13
 #http://sf.net/trustedqsl/TrustedQSL-([\d\.]+)\.tar\.gz

## trustedqsl 2.5.8

=== debian/changelog ===
trustedqsl (2.5.8-2) unstable; urgency=medium

  * Upload to unstable.

 -- tony mancill <tmancill@debian.org>  Sun, 15 Aug 2021 09:46:46 -0700

trustedqsl (2.5.8-1) experimental; urgency=medium

  * New upstream version 2.5.8
  * Bump Standards-Version to 4.5.1

 -- tony mancill <tmancill@debian.org>  Tue, 10 Aug 2021 21:02:17 -0700

trustedqsl (2.5.7-2) experimental; urgency=medium

  * Switch to LMDB; libdb is obsolete.

 -- Christoph Berg <myon@debian.org>  Sat, 24 Apr 2021 17:51:04 +0200

=== debian/control ===
--- 
+++ 
@@ -12,12 +12,12 @@
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libcurl4-openssl-dev,
-               libdb-dev,
                libexpat1-dev,
+               liblmdb-dev,
                libssl-dev,
                libwxgtk3.0-gtk3-dev,
                zlib1g-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/trustedqsl
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/trustedqsl.git
 Homepage: https://sourceforge.net/projects/trustedqsl/

## trustedqsl 2.5.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,8 +4,13 @@
 
 find_package(OpenSSL REQUIRED)
 
+
 if ( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
-  ADD_COMPILE_OPTIONS("-fPIC")
+  if ( CMAKE_VERSION VERSION_LESS 2.8.12 )
+    SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC" )
+  else()
+    ADD_COMPILE_OPTIONS("-fPIC")
+  endif ( CMAKE_VERSION VERSION_LESS 2.8.12 )
 endif( CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64" )
 
 SET (LINUX FALSE)

=== apps/CMakeLists.txt ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.arrl.tqsl")
 	set(MACOSX_BUNDLE_LONG_VERSION_STRING "TQSL V ${TQSLVERSION} build ${BUILD}")
 	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${TQSLVERSION}")
-	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2020 American Radio Relay League")
+	set(MACOSX_BUNDLE_COPYRIGHT "Copyright 2001-2021 American Radio Relay League")
 
 	set(MACOSX_BUNDLE_ICON_FILE ${OSX_ICONFILE})
 	SET_SOURCE_FILES_PROPERTIES(${OSX_ICONFILE} PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
@@ -107,7 +107,8 @@
 	install(FILES lang/it/tqslapp.mo DESTINATION share/locale/it/LC_MESSAGES)
 	install(FILES lang/ja/tqslapp.mo DESTINATION share/locale/ja/LC_MESSAGES)
 	install(FILES lang/pt/tqslapp.mo DESTINATION share/locale/pt/LC_MESSAGES)
-	install(FILES lang/zh/tqslapp.mo DESTINATION share/locale/zh/LC_MESSAGES)
+	install(FILES lang/zh_TW/tqslapp.mo DESTINATION share/locale/zh_TW/LC_MESSAGES)
+	install(FILES lang/zh_CN/tqslapp.mo DESTINATION share/locale/zh_CN/LC_MESSAGES)
 	install(FILES lang/ru/tqslapp.mo DESTINATION share/locale/ru/LC_MESSAGES)
 	install(FILES languages.dat DESTINATION share/TrustedQSL)
 	install(FILES cab_modes.dat DESTINATION share/TrustedQSL)

=== debian/changelog ===
trustedqsl (2.5.9-2) unstable; urgency=medium

  * Add patch for compatibility with OpenSSL 3 (Closes: #1001358)

 -- tony mancill <tmancill@debian.org>  Wed, 08 Dec 2021 18:56:31 -0800

trustedqsl (2.5.9-1) unstable; urgency=medium

  [ Christoph Berg ]
  * Retire Kamal, Jaime, Patrick, Jerry, and Colin from Uploaders.
    (Closes: #990593)

  [ tony mancill ]
  * New upstream version 2.5.9
  * Bump Standards-Version to 4.6.0
  * Update patches for new upstream release.

 -- tony mancill <tmancill@debian.org>  Sun, 07 Nov 2021 15:41:26 -0800

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,6 @@
 Source: trustedqsl
 Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
-Uploaders: Kamal Mostafa <kamal@whence.com>,
-           Jaime Robles <jaime@debian.org>,
-           Patrick Ouellette <pouelle@debian.org>,
-           Jerry Stueve <k4int@arrl.net>,
-           Colin Tuckley <colint@debian.org>,
-           Christoph Berg <myon@debian.org>,
+Uploaders: Christoph Berg <myon@debian.org>,
            tony mancill <tmancill@debian.org>
 Section: hamradio
 Priority: optional
@@ -17,7 +12,7 @@
                libssl-dev,
                libwxgtk3.0-gtk3-dev,
                zlib1g-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/trustedqsl
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/trustedqsl.git
 Homepage: https://sourceforge.net/projects/trustedqsl/
